import { PublicKey, Keypair } from '@solana/web3.js';
import { CypherClient } from '../client';
import { CacheAccountState, StateUpdateHandler, Cache } from '../types';
export declare class CacheAccount {
    readonly client: CypherClient;
    readonly address: PublicKey;
    state: CacheAccountState;
    private _onStateUpdate?;
    constructor(client: CypherClient, address: PublicKey, state: CacheAccountState, _onStateUpdate?: StateUpdateHandler<CacheAccountState>);
    static create(client: CypherClient, clearing: PublicKey, authority: PublicKey): Promise<{
        cacheAccount: PublicKey;
        ixs: import("@solana/web3.js").TransactionInstruction[];
        signers: Keypair[];
    }>;
    static load(client: CypherClient, address: PublicKey, onStateUpdateHandler?: StateUpdateHandler<CacheAccountState>): Promise<CacheAccount>;
    getCaches(): Cache[];
    getCache(idx: number): Cache;
    subscribe(): void;
    unsubscribe(): Promise<void>;
}
