"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uiToSplPrice = exports.uiToSplAmountFixed = exports.uiToSplAmount = exports.splToUiPrice = exports.splToUiAmountFixed = exports.splToUiAmount = exports.getQuoteFromBase = exports.fp32Mul = exports.priceLotsToNative = void 0;
const mango_client_1 = require("@blockworks-foundation/mango-client");
const anchor_1 = require("@project-serum/anchor");
function priceLotsToNative(priceLots, baseMultiplier, quoteMultiplier, decimals) {
    return priceLots
        .mul(quoteMultiplier)
        .mul(new anchor_1.BN(Math.pow(10, decimals)))
        .div(baseMultiplier);
}
exports.priceLotsToNative = priceLotsToNative;
///
//let res = price as u128 * quote_multiplier as u128 * coin_decimals_factor as u128
/// base_multiplier as u128;
function fp32Mul(a, bFp32) {
    return a.mul(bFp32).ushrn(32);
}
exports.fp32Mul = fp32Mul;
function getQuoteFromBase(baseAmount, scaledPriceFp32, baseMultiplier, quoteMultiplier) {
    return fp32Mul(baseAmount, scaledPriceFp32)
        .mul(quoteMultiplier)
        .div(baseMultiplier);
}
exports.getQuoteFromBase = getQuoteFromBase;
function splToUiAmount(splAmount, decimals) {
    return splAmount.toNumber() / Math.pow(10, decimals);
}
exports.splToUiAmount = splToUiAmount;
function splToUiAmountFixed(splAmount, decimals) {
    return splAmount.div(mango_client_1.I80F48.fromNumber(Math.pow(10, decimals)));
}
exports.splToUiAmountFixed = splToUiAmountFixed;
function splToUiPrice(splPrice, baseDecimals, quoteDecimals) {
    return ((splPrice.toNumber() * Math.pow(10, baseDecimals)) /
        Math.pow(10, quoteDecimals));
}
exports.splToUiPrice = splToUiPrice;
function uiToSplAmount(uiAmount, decimals) {
    return new anchor_1.BN(uiAmount * Math.pow(10, decimals));
}
exports.uiToSplAmount = uiToSplAmount;
function uiToSplAmountFixed(uiAmount, decimals) {
    return mango_client_1.I80F48.fromNumber(uiAmount).mul(mango_client_1.I80F48.fromNumber(Math.pow(10, decimals)));
}
exports.uiToSplAmountFixed = uiToSplAmountFixed;
function uiToSplPrice(uiPrice, baseDecimals, quoteDecimals) {
    return new anchor_1.BN(uiPrice * Math.pow(10, quoteDecimals)).divn(Math.pow(10, baseDecimals));
}
exports.uiToSplPrice = uiToSplPrice;
//# sourceMappingURL=tokenAmount.js.map